<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-pragma">{-# LANGUAGE DataKinds             #-}</span><span>
</span><span id="line-2"></span><span class="hs-pragma">{-# LANGUAGE TypeFamilies          #-}</span><span>
</span><span id="line-3"></span><span class="hs-pragma">{-# LANGUAGE DeriveAnyClass        #-}</span><span>
</span><span id="line-4"></span><span class="hs-pragma">{-# LANGUAGE DeriveFunctor         #-}</span><span>
</span><span id="line-5"></span><span class="hs-pragma">{-# LANGUAGE DeriveGeneric         #-}</span><span>
</span><span id="line-6"></span><span class="hs-pragma">{-# LANGUAGE DuplicateRecordFields #-}</span><span>
</span><span id="line-7"></span><span class="hs-pragma">{-# LANGUAGE MultiWayIf            #-}</span><span>
</span><span id="line-8"></span><span class="hs-pragma">{-# LANGUAGE OverloadedStrings     #-}</span><span>
</span><span id="line-9"></span><span class="hs-pragma">{-# LANGUAGE PolyKinds             #-}</span><span>
</span><span id="line-10"></span><span class="hs-pragma">{-# LANGUAGE RecordWildCards       #-}</span><span>
</span><span id="line-11"></span><span class="hs-pragma">{-# LANGUAGE ScopedTypeVariables   #-}</span><span>
</span><span id="line-12"></span><span class="hs-pragma">{-# LANGUAGE TypeApplications      #-}</span><span>
</span><span id="line-13"></span><span>
</span><span id="line-14"></span><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Hyperion.Bootstrap.OPESearch.BilinearForms</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-15"></span><span>
</span><span id="line-16"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Aeson</span></span><span>                      </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">FromJSON</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier">ToJSON</span></span><span class="hs-special">)</span><span>
</span><span id="line-17"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Binary</span></span><span>                     </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">Binary</span></span><span class="hs-special">)</span><span>
</span><span id="line-18"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.List.Extra</span></span><span>                 </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">maximumOn</span></span><span class="hs-special">)</span><span>
</span><span id="line-19"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Matrix.Static</span></span><span>              </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">Matrix</span></span><span class="hs-special">)</span><span>
</span><span id="line-20"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.Matrix.Static</span></span><span>              </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">M</span></span><span>
</span><span id="line-21"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Ratio</span></span><span>                      </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">approxRational</span></span><span class="hs-special">)</span><span>
</span><span id="line-22"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Vector.Binary</span></span><span>              </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-23"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">GHC.Generics</span></span><span>                    </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">Generic</span></span><span class="hs-special">)</span><span>
</span><span id="line-24"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><a href="Hyperion.Bootstrap.BoolFunction.html"><span class="hs-identifier">Hyperion.Bootstrap.BoolFunction</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.BoolFunction.html#BoolFunction"><span class="hs-identifier">BoolFunction</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-25"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.BoolFunction.html"><span class="hs-identifier">Hyperion.Bootstrap.BoolFunction</span></a></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">B</span></span><span>
</span><span id="line-26"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Linear.V</span></span><span>                        </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">V</span></span><span class="hs-special">)</span><span>
</span><span id="line-27"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">SDPB.Math.Linear.Literal</span></span><span>        </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">L</span></span><span>
</span><span id="line-28"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">SDPB.Math.Linear.Util</span></span><span>           </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">L</span></span><span>
</span><span id="line-29"></span><span>
</span><span id="line-30"></span><span id="local-6989586621679449143"><span id="local-6989586621679449144"></span></span><span class="hs-keyword">data</span><span> </span><span id="BilinearForms"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-var">BilinearForms</span></a></span></span><span> </span><span id="local-6989586621679449196"><span class="annot"><a href="#local-6989586621679449196"><span class="hs-identifier hs-type">j</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span id="BilinearForms"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-var">BilinearForms</span></a></span></span><span>
</span><span id="line-31"></span><span>  </span><span class="hs-special">{</span><span> </span><span id="%24sel%3AbfResolution%3ABilinearForms"><span class="annot"><span class="annottext">BilinearForms j -&gt; Double
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#%24sel%3AbfResolution%3ABilinearForms"><span class="hs-identifier hs-var hs-var">bfResolution</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span>
</span><span id="line-32"></span><span>  </span><span class="hs-special">,</span><span> </span><span id="%24sel%3AbfMatrices%3ABilinearForms"><span class="annot"><span class="annottext">BilinearForms j -&gt; [(Maybe (V j Rational), Matrix j j Rational)]
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#%24sel%3AbfMatrices%3ABilinearForms"><span class="hs-identifier hs-var hs-var">bfMatrices</span></a></span></span><span>   </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">[</span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V</span></span><span> </span><span class="annot"><a href="#local-6989586621679449196"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span class="hs-special">)</span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Matrix</span></span><span> </span><span class="annot"><a href="#local-6989586621679449196"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449196"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span class="hs-special">)</span><span class="hs-special">]</span><span>
</span><span id="line-33"></span><span>  </span><span class="hs-special">}</span><span> </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679449134"><span id="local-6989586621679449136"><span id="local-6989586621679449138"><span class="annot"><span class="annottext">Int -&gt; BilinearForms j -&gt; ShowS
[BilinearForms j] -&gt; ShowS
BilinearForms j -&gt; String
(Int -&gt; BilinearForms j -&gt; ShowS)
-&gt; (BilinearForms j -&gt; String)
-&gt; ([BilinearForms j] -&gt; ShowS)
-&gt; Show (BilinearForms j)
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
forall (j :: Nat). Int -&gt; BilinearForms j -&gt; ShowS
forall (j :: Nat). [BilinearForms j] -&gt; ShowS
forall (j :: Nat). BilinearForms j -&gt; String
showList :: [BilinearForms j] -&gt; ShowS
$cshowList :: forall (j :: Nat). [BilinearForms j] -&gt; ShowS
show :: BilinearForms j -&gt; String
$cshow :: forall (j :: Nat). BilinearForms j -&gt; String
showsPrec :: Int -&gt; BilinearForms j -&gt; ShowS
$cshowsPrec :: forall (j :: Nat). Int -&gt; BilinearForms j -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679449129"><span id="local-6989586621679449131"><span class="annot"><span class="annottext">BilinearForms j -&gt; BilinearForms j -&gt; Bool
(BilinearForms j -&gt; BilinearForms j -&gt; Bool)
-&gt; (BilinearForms j -&gt; BilinearForms j -&gt; Bool)
-&gt; Eq (BilinearForms j)
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
forall (j :: Nat). BilinearForms j -&gt; BilinearForms j -&gt; Bool
/= :: BilinearForms j -&gt; BilinearForms j -&gt; Bool
$c/= :: forall (j :: Nat). BilinearForms j -&gt; BilinearForms j -&gt; Bool
== :: BilinearForms j -&gt; BilinearForms j -&gt; Bool
$c== :: forall (j :: Nat). BilinearForms j -&gt; BilinearForms j -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">(forall x. BilinearForms j -&gt; Rep (BilinearForms j) x)
-&gt; (forall x. Rep (BilinearForms j) x -&gt; BilinearForms j)
-&gt; Generic (BilinearForms j)
forall x. Rep (BilinearForms j) x -&gt; BilinearForms j
forall x. BilinearForms j -&gt; Rep (BilinearForms j) x
forall a.
(forall x. a -&gt; Rep a x) -&gt; (forall x. Rep a x -&gt; a) -&gt; Generic a
forall (j :: Nat) x. Rep (BilinearForms j) x -&gt; BilinearForms j
forall (j :: Nat) x. BilinearForms j -&gt; Rep (BilinearForms j) x
$cto :: forall (j :: Nat) x. Rep (BilinearForms j) x -&gt; BilinearForms j
$cfrom :: forall (j :: Nat) x. BilinearForms j -&gt; Rep (BilinearForms j) x
</span><span class="hs-identifier hs-var hs-var hs-var hs-var">Generic</span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679449119"><span id="local-6989586621679449121"><span id="local-6989586621679449123"><span class="annot"><span class="annottext">Get (BilinearForms j)
[BilinearForms j] -&gt; Put
BilinearForms j -&gt; Put
(BilinearForms j -&gt; Put)
-&gt; Get (BilinearForms j)
-&gt; ([BilinearForms j] -&gt; Put)
-&gt; Binary (BilinearForms j)
forall t. (t -&gt; Put) -&gt; Get t -&gt; ([t] -&gt; Put) -&gt; Binary t
forall (j :: Nat). KnownNat j =&gt; Get (BilinearForms j)
forall (j :: Nat). KnownNat j =&gt; [BilinearForms j] -&gt; Put
forall (j :: Nat). KnownNat j =&gt; BilinearForms j -&gt; Put
putList :: [BilinearForms j] -&gt; Put
$cputList :: forall (j :: Nat). KnownNat j =&gt; [BilinearForms j] -&gt; Put
get :: Get (BilinearForms j)
$cget :: forall (j :: Nat). KnownNat j =&gt; Get (BilinearForms j)
put :: BilinearForms j -&gt; Put
$cput :: forall (j :: Nat). KnownNat j =&gt; BilinearForms j -&gt; Put
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Binary</span></span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679449114"><span id="local-6989586621679449116"><span class="annot"><span class="annottext">Value -&gt; Parser [BilinearForms j]
Value -&gt; Parser (BilinearForms j)
(Value -&gt; Parser (BilinearForms j))
-&gt; (Value -&gt; Parser [BilinearForms j])
-&gt; FromJSON (BilinearForms j)
forall a.
(Value -&gt; Parser a) -&gt; (Value -&gt; Parser [a]) -&gt; FromJSON a
forall (j :: Nat). KnownNat j =&gt; Value -&gt; Parser [BilinearForms j]
forall (j :: Nat). KnownNat j =&gt; Value -&gt; Parser (BilinearForms j)
parseJSONList :: Value -&gt; Parser [BilinearForms j]
$cparseJSONList :: forall (j :: Nat). KnownNat j =&gt; Value -&gt; Parser [BilinearForms j]
parseJSON :: Value -&gt; Parser (BilinearForms j)
$cparseJSON :: forall (j :: Nat). KnownNat j =&gt; Value -&gt; Parser (BilinearForms j)
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">FromJSON</span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679449105"><span id="local-6989586621679449107"><span id="local-6989586621679449109"><span id="local-6989586621679449111"><span class="annot"><span class="annottext">[BilinearForms j] -&gt; Encoding
[BilinearForms j] -&gt; Value
BilinearForms j -&gt; Encoding
BilinearForms j -&gt; Value
(BilinearForms j -&gt; Value)
-&gt; (BilinearForms j -&gt; Encoding)
-&gt; ([BilinearForms j] -&gt; Value)
-&gt; ([BilinearForms j] -&gt; Encoding)
-&gt; ToJSON (BilinearForms j)
forall a.
(a -&gt; Value)
-&gt; (a -&gt; Encoding)
-&gt; ([a] -&gt; Value)
-&gt; ([a] -&gt; Encoding)
-&gt; ToJSON a
forall (j :: Nat). KnownNat j =&gt; [BilinearForms j] -&gt; Encoding
forall (j :: Nat). KnownNat j =&gt; [BilinearForms j] -&gt; Value
forall (j :: Nat). KnownNat j =&gt; BilinearForms j -&gt; Encoding
forall (j :: Nat). KnownNat j =&gt; BilinearForms j -&gt; Value
toEncodingList :: [BilinearForms j] -&gt; Encoding
$ctoEncodingList :: forall (j :: Nat). KnownNat j =&gt; [BilinearForms j] -&gt; Encoding
toJSONList :: [BilinearForms j] -&gt; Value
$ctoJSONList :: forall (j :: Nat). KnownNat j =&gt; [BilinearForms j] -&gt; Value
toEncoding :: BilinearForms j -&gt; Encoding
$ctoEncoding :: forall (j :: Nat). KnownNat j =&gt; BilinearForms j -&gt; Encoding
toJSON :: BilinearForms j -&gt; Value
$ctoJSON :: forall (j :: Nat). KnownNat j =&gt; BilinearForms j -&gt; Value
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">ToJSON</span></span></span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-34"></span><span>
</span><span id="line-35"></span><span id="local-6989586621679449103"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#addBilinearForm"><span class="hs-identifier hs-type">addBilinearForm</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Matrix</span></span><span> </span><span class="annot"><a href="#local-6989586621679449103"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449103"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449103"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449103"><span class="hs-identifier hs-type">j</span></a></span></span><span>
</span><span id="line-36"></span><span id="addBilinearForm"><span class="annot"><span class="annottext">addBilinearForm :: Matrix j j Rational -&gt; BilinearForms j -&gt; BilinearForms j
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#addBilinearForm"><span class="hs-identifier hs-var hs-var">addBilinearForm</span></a></span></span><span> </span><span id="local-6989586621679449101"><span class="annot"><span class="annottext">Matrix j j Rational
</span><a href="#local-6989586621679449101"><span class="hs-identifier hs-var">m</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span id="local-6989586621679449100"><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449100"><span class="hs-identifier hs-var">r</span></a></span></span><span> </span><span id="local-6989586621679449099"><span class="annot"><span class="annottext">[(Maybe (V j Rational), Matrix j j Rational)]
</span><a href="#local-6989586621679449099"><span class="hs-identifier hs-var">ms</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Double
-&gt; [(Maybe (V j Rational), Matrix j j Rational)] -&gt; BilinearForms j
forall (j :: Nat).
Double
-&gt; [(Maybe (V j Rational), Matrix j j Rational)] -&gt; BilinearForms j
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-var">BilinearForms</span></a></span><span> </span><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449100"><span class="hs-identifier hs-var">r</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">(</span><span class="annot"><span class="annottext">Maybe (V j Rational)
forall a. Maybe a
</span><span class="hs-identifier hs-var">Nothing</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Matrix j j Rational
</span><a href="#local-6989586621679449101"><span class="hs-identifier hs-var">m</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">(Maybe (V j Rational), Matrix j j Rational)
-&gt; [(Maybe (V j Rational), Matrix j j Rational)]
-&gt; [(Maybe (V j Rational), Matrix j j Rational)]
forall a. a -&gt; [a] -&gt; [a]
</span><span class="hs-glyph hs-var">:</span></span><span> </span><span class="annot"><span class="annottext">[(Maybe (V j Rational), Matrix j j Rational)]
</span><a href="#local-6989586621679449099"><span class="hs-identifier hs-var">ms</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-37"></span><span>
</span><span id="line-38"></span><span id="local-6989586621679449098"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#setFeasibleVector"><span class="hs-identifier hs-type">setFeasibleVector</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V</span></span><span> </span><span class="annot"><a href="#local-6989586621679449098"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449098"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449098"><span class="hs-identifier hs-type">j</span></a></span></span><span>
</span><span id="line-39"></span><span id="setFeasibleVector"><span class="annot"><span class="annottext">setFeasibleVector :: Maybe (V j Rational) -&gt; BilinearForms j -&gt; BilinearForms j
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#setFeasibleVector"><span class="hs-identifier hs-var hs-var">setFeasibleVector</span></a></span></span><span> </span><span id="local-6989586621679449096"><span class="annot"><span class="annottext">Maybe (V j Rational)
</span><a href="#local-6989586621679449096"><span class="hs-identifier hs-var">mv</span></a></span></span><span> </span><span id="local-6989586621679449095"><span class="annot"><span class="annottext">BilinearForms j
</span><a href="#local-6989586621679449095"><span class="hs-identifier hs-var">b</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">BilinearForms j
</span><a href="#local-6989586621679449095"><span class="hs-identifier hs-var">b</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-40"></span><span>  </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span id="local-6989586621679449094"><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449094"><span class="hs-identifier hs-var">r</span></a></span></span><span> </span><span class="hs-special">(</span><span class="hs-special">(</span><span class="annot"><span class="annottext">Maybe (V j Rational)
</span><span class="hs-identifier">_</span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679449093"><span class="annot"><span class="annottext">Matrix j j Rational
</span><a href="#local-6989586621679449093"><span class="hs-identifier hs-var">m</span></a></span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="hs-glyph hs-type">:</span></span><span> </span><span id="local-6989586621679449092"><span class="annot"><span class="annottext">[(Maybe (V j Rational), Matrix j j Rational)]
</span><a href="#local-6989586621679449092"><span class="hs-identifier hs-var">ms</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Double
-&gt; [(Maybe (V j Rational), Matrix j j Rational)] -&gt; BilinearForms j
forall (j :: Nat).
Double
-&gt; [(Maybe (V j Rational), Matrix j j Rational)] -&gt; BilinearForms j
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-var">BilinearForms</span></a></span><span> </span><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449094"><span class="hs-identifier hs-var">r</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">(</span><span class="annot"><span class="annottext">Maybe (V j Rational)
</span><a href="#local-6989586621679449096"><span class="hs-identifier hs-var">mv</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Matrix j j Rational
</span><a href="#local-6989586621679449093"><span class="hs-identifier hs-var">m</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">(Maybe (V j Rational), Matrix j j Rational)
-&gt; [(Maybe (V j Rational), Matrix j j Rational)]
-&gt; [(Maybe (V j Rational), Matrix j j Rational)]
forall a. a -&gt; [a] -&gt; [a]
</span><span class="hs-glyph hs-var">:</span></span><span> </span><span class="annot"><span class="annottext">[(Maybe (V j Rational), Matrix j j Rational)]
</span><a href="#local-6989586621679449092"><span class="hs-identifier hs-var">ms</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-41"></span><span>  </span><span class="annot"><span class="annottext">BilinearForms j
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">String -&gt; BilinearForms j
forall a. HasCallStack =&gt; String -&gt; a
</span><span class="hs-identifier hs-var">error</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Cannot set feasible vector for empty bilinear forms&quot;</span></span><span>
</span><span id="line-42"></span><span>
</span><span id="line-43"></span><span id="local-6989586621679449090"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#feasibleVector"><span class="hs-identifier hs-type">feasibleVector</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449090"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V</span></span><span> </span><span class="annot"><a href="#local-6989586621679449090"><span class="hs-identifier hs-type">j</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span class="hs-special">)</span></span><span>
</span><span id="line-44"></span><span id="feasibleVector"><span class="annot"><span class="annottext">feasibleVector :: BilinearForms j -&gt; Maybe (V j Rational)
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#feasibleVector"><span class="hs-identifier hs-var hs-var">feasibleVector</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#BilinearForms"><span class="hs-identifier hs-type">BilinearForms</span></a></span><span> </span><span class="annot"><span class="annottext">Double
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-special">(</span><span class="hs-special">(</span><span id="local-6989586621679449088"><span class="annot"><span class="annottext">Maybe (V j Rational)
</span><a href="#local-6989586621679449088"><span class="hs-identifier hs-var">mv</span></a></span></span><span class="hs-special">,</span><span class="annot"><span class="annottext">Matrix j j Rational
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="hs-glyph hs-type">:</span></span><span> </span><span class="annot"><span class="annottext">[(Maybe (V j Rational), Matrix j j Rational)]
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Maybe (V j Rational)
</span><a href="#local-6989586621679449088"><span class="hs-identifier hs-var">mv</span></a></span><span>
</span><span id="line-45"></span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#feasibleVector"><span class="hs-identifier hs-var">feasibleVector</span></a></span><span> </span><span class="annot"><span class="annottext">BilinearForms j
</span><span class="hs-identifier">_</span></span><span>                              </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Maybe (V j Rational)
forall a. Maybe a
</span><span class="hs-identifier hs-var">Nothing</span></span><span>
</span><span id="line-46"></span><span>
</span><span id="line-47"></span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#thetaIntervalFormApprox"><span class="hs-identifier hs-type">thetaIntervalFormApprox</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Matrix</span></span><span> </span><span class="annot"><span class="hs-number">2</span></span><span> </span><span class="annot"><span class="hs-number">2</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span>
</span><span id="line-48"></span><span id="thetaIntervalFormApprox"><span class="annot"><span class="annottext">thetaIntervalFormApprox :: Double -&gt; Rational -&gt; Rational -&gt; Matrix 2 2 Rational
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#thetaIntervalFormApprox"><span class="hs-identifier hs-var hs-var">thetaIntervalFormApprox</span></a></span></span><span> </span><span id="local-6989586621679449086"><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449086"><span class="hs-identifier hs-var">res</span></a></span></span><span> </span><span id="local-6989586621679449085"><span class="annot"><span class="annottext">Rational
</span><a href="#local-6989586621679449085"><span class="hs-identifier hs-var">thMin'</span></a></span></span><span> </span><span id="local-6989586621679449084"><span class="annot"><span class="annottext">Rational
</span><a href="#local-6989586621679449084"><span class="hs-identifier hs-var">thMax'</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-49"></span><span>  </span><span class="annot"><span class="annottext">(Double -&gt; Rational) -&gt; Matrix 2 2 Double -&gt; Matrix 2 2 Rational
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Double -&gt; Double -&gt; Rational
forall a. RealFrac a =&gt; a -&gt; a -&gt; Rational
</span><span class="hs-operator hs-var">`approxRational`</span></span><span> </span><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449086"><span class="hs-identifier hs-var">res</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Double -&gt; Double -&gt; Matrix 2 2 Double
forall (m :: Nat) (n :: Nat) b a.
(TupleMatrix m n, Floating b,
 HomogeneousTupleMatrix m n a ~ ((b, b), (b, b))) =&gt;
b -&gt; b -&gt; Matrix m n a
</span><a href="#local-6989586621679449083"><span class="hs-identifier hs-var">thetaIntervalForm</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Rational -&gt; Double
forall a. Fractional a =&gt; Rational -&gt; a
</span><span class="hs-identifier hs-var">fromRational</span></span><span> </span><span class="annot"><span class="annottext">Rational
</span><a href="#local-6989586621679449085"><span class="hs-identifier hs-var">thMin'</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Rational -&gt; Double
forall a. Fractional a =&gt; Rational -&gt; a
</span><span class="hs-identifier hs-var">fromRational</span></span><span> </span><span class="annot"><span class="annottext">Rational
</span><a href="#local-6989586621679449084"><span class="hs-identifier hs-var">thMax'</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-50"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-51"></span><span>    </span><span id="local-6989586621679449083"><span class="annot"><span class="annottext">thetaIntervalForm :: b -&gt; b -&gt; Matrix m n a
</span><a href="#local-6989586621679449083"><span class="hs-identifier hs-var hs-var">thetaIntervalForm</span></a></span></span><span> </span><span id="local-6989586621679449082"><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449082"><span class="hs-identifier hs-var">thMin</span></a></span></span><span> </span><span id="local-6989586621679449081"><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449081"><span class="hs-identifier hs-var">thMax</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">HomogeneousTupleMatrix m n a -&gt; Matrix m n a
forall (m :: Nat) (n :: Nat) a.
TupleMatrix m n =&gt;
HomogeneousTupleMatrix m n a -&gt; Matrix m n a
</span><span class="hs-identifier hs-var">L.toM</span></span><span>
</span><span id="line-52"></span><span>      </span><span class="hs-special">(</span><span> </span><span class="hs-special">(</span><span> </span><span class="annot"><span class="annottext">b
</span><span class="hs-number">2</span></span><span> </span><span class="annot"><span class="annottext">b -&gt; b -&gt; b
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">*</span></span><span> </span><span class="annot"><span class="annottext">b -&gt; b
forall a. Floating a =&gt; a -&gt; a
</span><span class="hs-identifier hs-var">sin</span></span><span> </span><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449082"><span class="hs-identifier hs-var">thMin</span></a></span><span> </span><span class="annot"><span class="annottext">b -&gt; b -&gt; b
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">*</span></span><span> </span><span class="annot"><span class="annottext">b -&gt; b
forall a. Floating a =&gt; a -&gt; a
</span><span class="hs-identifier hs-var">sin</span></span><span> </span><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449081"><span class="hs-identifier hs-var">thMax</span></a></span><span class="hs-special">,</span><span> </span><span class="hs-glyph">-</span><span> </span><span class="annot"><span class="annottext">b -&gt; b
forall a. Floating a =&gt; a -&gt; a
</span><span class="hs-identifier hs-var">sin</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449082"><span class="hs-identifier hs-var">thMin</span></a></span><span> </span><span class="annot"><span class="annottext">b -&gt; b -&gt; b
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">+</span></span><span> </span><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449081"><span class="hs-identifier hs-var">thMax</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">)</span><span>
</span><span id="line-53"></span><span>      </span><span class="hs-special">,</span><span> </span><span class="hs-special">(</span><span> </span><span class="hs-glyph">-</span><span> </span><span class="annot"><span class="annottext">b -&gt; b
forall a. Floating a =&gt; a -&gt; a
</span><span class="hs-identifier hs-var">sin</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449082"><span class="hs-identifier hs-var">thMin</span></a></span><span> </span><span class="annot"><span class="annottext">b -&gt; b -&gt; b
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">+</span></span><span> </span><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449081"><span class="hs-identifier hs-var">thMax</span></a></span><span class="hs-special">)</span><span>    </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">b
</span><span class="hs-number">2</span></span><span> </span><span class="annot"><span class="annottext">b -&gt; b -&gt; b
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">*</span></span><span> </span><span class="annot"><span class="annottext">b -&gt; b
forall a. Floating a =&gt; a -&gt; a
</span><span class="hs-identifier hs-var">cos</span></span><span> </span><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449082"><span class="hs-identifier hs-var">thMin</span></a></span><span> </span><span class="annot"><span class="annottext">b -&gt; b -&gt; b
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">*</span></span><span> </span><span class="annot"><span class="annottext">b -&gt; b
forall a. Floating a =&gt; a -&gt; a
</span><span class="hs-identifier hs-var">cos</span></span><span> </span><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449081"><span class="hs-identifier hs-var">thMax</span></a></span><span> </span><span class="hs-special">)</span><span>
</span><span id="line-54"></span><span>      </span><span class="hs-special">)</span><span>
</span><span id="line-55"></span><span>
</span><span id="line-56"></span><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#thetaVectorApprox"><span class="hs-identifier hs-type">thetaVectorApprox</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">V</span></span><span> </span><span class="annot"><span class="hs-number">2</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Rational</span></span><span>
</span><span id="line-57"></span><span id="thetaVectorApprox"><span class="annot"><span class="annottext">thetaVectorApprox :: Double -&gt; Rational -&gt; V 2 Rational
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#thetaVectorApprox"><span class="hs-identifier hs-var hs-var">thetaVectorApprox</span></a></span></span><span> </span><span id="local-6989586621679449074"><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449074"><span class="hs-identifier hs-var">res</span></a></span></span><span> </span><span id="local-6989586621679449073"><span class="annot"><span class="annottext">Rational
</span><a href="#local-6989586621679449073"><span class="hs-identifier hs-var">th'</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-58"></span><span>  </span><span class="annot"><span class="annottext">(Double -&gt; Rational) -&gt; V 2 Double -&gt; V 2 Rational
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Double -&gt; Double -&gt; Rational
forall a. RealFrac a =&gt; a -&gt; a -&gt; Rational
</span><span class="hs-operator hs-var">`approxRational`</span></span><span> </span><span class="annot"><span class="annottext">Double
</span><a href="#local-6989586621679449074"><span class="hs-identifier hs-var">res</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Double -&gt; V 2 Double
forall (n :: Nat) b a.
(TupleVector n, Floating b, HomogeneousTuple n a ~ (b, b)) =&gt;
b -&gt; V n a
</span><a href="#local-6989586621679449072"><span class="hs-identifier hs-var">thetaVector</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Rational -&gt; Double
forall a. Fractional a =&gt; Rational -&gt; a
</span><span class="hs-identifier hs-var">fromRational</span></span><span> </span><span class="annot"><span class="annottext">Rational
</span><a href="#local-6989586621679449073"><span class="hs-identifier hs-var">th'</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-59"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-60"></span><span>    </span><span id="local-6989586621679449072"><span class="annot"><span class="annottext">thetaVector :: b -&gt; V n a
</span><a href="#local-6989586621679449072"><span class="hs-identifier hs-var hs-var">thetaVector</span></a></span></span><span> </span><span id="local-6989586621679449071"><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449071"><span class="hs-identifier hs-var">th</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">HomogeneousTuple n a -&gt; V n a
forall (n :: Nat) a. TupleVector n =&gt; HomogeneousTuple n a -&gt; V n a
</span><span class="hs-identifier hs-var">L.toV</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">b -&gt; b
forall a. Floating a =&gt; a -&gt; a
</span><span class="hs-identifier hs-var">cos</span></span><span> </span><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449071"><span class="hs-identifier hs-var">th</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">b -&gt; b
forall a. Floating a =&gt; a -&gt; a
</span><span class="hs-identifier hs-var">sin</span></span><span> </span><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679449071"><span class="hs-identifier hs-var">th</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-61"></span><span>
</span><span id="line-62"></span><span class="hs-comment">-- A non-definite 2x2 bilinear form ((a,b),(b,d)) has two null</span><span>
</span><span id="line-63"></span><span class="hs-comment">-- directions of the form (1,t1) and (1,t2). This function returns a</span><span>
</span><span id="line-64"></span><span class="hs-comment">-- BoolFunction of t that is positive in the positive range of m</span><span>
</span><span id="line-65"></span><span class="hs-comment">-- between these two vectors.</span><span>
</span><span id="line-66"></span><span class="hs-comment">--</span><span>
</span><span id="line-67"></span><span class="hs-comment">-- Warning: this function fails if d=0</span><span>
</span><span id="line-68"></span><span id="local-6989586621679449069"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#positiveInterval"><span class="hs-identifier hs-type">positiveInterval</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Floating</span></span><span> </span><span class="annot"><a href="#local-6989586621679449069"><span class="hs-identifier hs-type">a</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ord</span></span><span> </span><span class="annot"><a href="#local-6989586621679449069"><span class="hs-identifier hs-type">a</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Matrix</span></span><span> </span><span class="annot"><span class="hs-number">2</span></span><span> </span><span class="annot"><span class="hs-number">2</span></span><span> </span><span class="annot"><a href="#local-6989586621679449069"><span class="hs-identifier hs-type">a</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.BoolFunction.html#BoolFunction"><span class="hs-identifier hs-type">BoolFunction</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449069"><span class="hs-identifier hs-type">a</span></a></span></span><span>
</span><span id="line-69"></span><span id="positiveInterval"><span class="annot"><span class="annottext">positiveInterval :: Matrix 2 2 a -&gt; BoolFunction a
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#positiveInterval"><span class="hs-identifier hs-var hs-var">positiveInterval</span></a></span></span><span> </span><span id="local-6989586621679449067"><span class="annot"><span class="annottext">Matrix 2 2 a
</span><a href="#local-6989586621679449067"><span class="hs-identifier hs-var">m</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-70"></span><span>  </span><span class="hs-keyword">if</span><span> </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449066"><span class="hs-identifier hs-var">disc</span></a></span><span> </span><span class="annot"><span class="annottext">a -&gt; a -&gt; Bool
forall a. Ord a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">&lt;=</span></span><span> </span><span class="annot"><span class="annottext">a
</span><span class="hs-number">0</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Bool -&gt; BoolFunction a
forall a. Bool -&gt; BoolFunction a
</span><a href="Hyperion.Bootstrap.BoolFunction.html#fromConst"><span class="hs-identifier hs-var">B.fromConst</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449063"><span class="hs-identifier hs-var">a</span></a></span><span> </span><span class="annot"><span class="annottext">a -&gt; a -&gt; Bool
forall a. Ord a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">&gt;</span></span><span> </span><span class="annot"><span class="annottext">a
</span><span class="hs-number">0</span></span><span class="hs-special">)</span><span>
</span><span id="line-71"></span><span>     </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449061"><span class="hs-identifier hs-var">d</span></a></span><span> </span><span class="annot"><span class="annottext">a -&gt; a -&gt; Bool
forall a. Ord a =&gt; a -&gt; a -&gt; Bool
</span><span class="hs-operator hs-var">&lt;</span></span><span> </span><span class="annot"><span class="annottext">a
</span><span class="hs-number">0</span></span><span>     </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">a -&gt; a -&gt; BoolFunction a
forall a. Ord a =&gt; a -&gt; a -&gt; BoolFunction a
</span><a href="Hyperion.Bootstrap.BoolFunction.html#interval"><span class="hs-identifier hs-var">B.interval</span></a></span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449058"><span class="hs-identifier hs-var">t2</span></a></span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449057"><span class="hs-identifier hs-var">t1</span></a></span><span>
</span><span id="line-72"></span><span>     </span><span class="hs-glyph">|</span><span> </span><span class="annot"><span class="annottext">Bool
</span><span class="hs-identifier hs-var">otherwise</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">BoolFunction a -&gt; BoolFunction a
forall a. BoolFunction a -&gt; BoolFunction a
</span><a href="Hyperion.Bootstrap.BoolFunction.html#not"><span class="hs-identifier hs-var">B.not</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">a -&gt; a -&gt; BoolFunction a
forall a. Ord a =&gt; a -&gt; a -&gt; BoolFunction a
</span><a href="Hyperion.Bootstrap.BoolFunction.html#interval"><span class="hs-identifier hs-var">B.interval</span></a></span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449057"><span class="hs-identifier hs-var">t1</span></a></span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449058"><span class="hs-identifier hs-var">t2</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-73"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-74"></span><span>    </span><span id="local-6989586621679449063"><span class="annot"><span class="annottext">a :: a
</span><a href="#local-6989586621679449063"><span class="hs-identifier hs-var hs-var">a</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Matrix 2 2 a
</span><a href="#local-6989586621679449067"><span class="hs-identifier hs-var">m</span></a></span><span> </span><span class="annot"><span class="annottext">Matrix 2 2 a -&gt; (Int, Int) -&gt; a
forall (m :: Nat) (n :: Nat) a. Matrix m n a -&gt; (Int, Int) -&gt; a
</span><span class="hs-operator hs-var">M.!</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">1</span></span><span class="hs-special">,</span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">1</span></span><span class="hs-special">)</span><span>
</span><span id="line-75"></span><span>    </span><span id="local-6989586621679449054"><span class="annot"><span class="annottext">b :: a
</span><a href="#local-6989586621679449054"><span class="hs-identifier hs-var hs-var">b</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Matrix 2 2 a
</span><a href="#local-6989586621679449067"><span class="hs-identifier hs-var">m</span></a></span><span> </span><span class="annot"><span class="annottext">Matrix 2 2 a -&gt; (Int, Int) -&gt; a
forall (m :: Nat) (n :: Nat) a. Matrix m n a -&gt; (Int, Int) -&gt; a
</span><span class="hs-operator hs-var">M.!</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">1</span></span><span class="hs-special">,</span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">2</span></span><span class="hs-special">)</span><span>
</span><span id="line-76"></span><span>    </span><span id="local-6989586621679449061"><span class="annot"><span class="annottext">d :: a
</span><a href="#local-6989586621679449061"><span class="hs-identifier hs-var hs-var">d</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Matrix 2 2 a
</span><a href="#local-6989586621679449067"><span class="hs-identifier hs-var">m</span></a></span><span> </span><span class="annot"><span class="annottext">Matrix 2 2 a -&gt; (Int, Int) -&gt; a
forall (m :: Nat) (n :: Nat) a. Matrix m n a -&gt; (Int, Int) -&gt; a
</span><span class="hs-operator hs-var">M.!</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">2</span></span><span class="hs-special">,</span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">2</span></span><span class="hs-special">)</span><span>
</span><span id="line-77"></span><span>    </span><span id="local-6989586621679449066"><span class="annot"><span class="annottext">disc :: a
</span><a href="#local-6989586621679449066"><span class="hs-identifier hs-var hs-var">disc</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449054"><span class="hs-identifier hs-var">b</span></a></span><span class="annot"><span class="annottext">a -&gt; a -&gt; a
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">*</span></span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449054"><span class="hs-identifier hs-var">b</span></a></span><span> </span><span class="annot"><span class="annottext">a -&gt; a -&gt; a
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-glyph hs-var">-</span></span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449063"><span class="hs-identifier hs-var">a</span></a></span><span class="annot"><span class="annottext">a -&gt; a -&gt; a
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">*</span></span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449061"><span class="hs-identifier hs-var">d</span></a></span><span>
</span><span id="line-78"></span><span>    </span><span id="local-6989586621679449057"><span class="annot"><span class="annottext">t1 :: a
</span><a href="#local-6989586621679449057"><span class="hs-identifier hs-var hs-var">t1</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">(</span><span class="hs-glyph">-</span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449054"><span class="hs-identifier hs-var">b</span></a></span><span> </span><span class="annot"><span class="annottext">a -&gt; a -&gt; a
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-glyph hs-var">-</span></span><span> </span><span class="annot"><span class="annottext">a -&gt; a
forall a. Floating a =&gt; a -&gt; a
</span><span class="hs-identifier hs-var">sqrt</span></span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449066"><span class="hs-identifier hs-var">disc</span></a></span><span class="hs-special">)</span><span class="annot"><span class="annottext">a -&gt; a -&gt; a
forall a. Fractional a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">/</span></span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449061"><span class="hs-identifier hs-var">d</span></a></span><span>
</span><span id="line-79"></span><span>    </span><span id="local-6989586621679449058"><span class="annot"><span class="annottext">t2 :: a
</span><a href="#local-6989586621679449058"><span class="hs-identifier hs-var hs-var">t2</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">(</span><span class="hs-glyph">-</span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449054"><span class="hs-identifier hs-var">b</span></a></span><span> </span><span class="annot"><span class="annottext">a -&gt; a -&gt; a
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">+</span></span><span> </span><span class="annot"><span class="annottext">a -&gt; a
forall a. Floating a =&gt; a -&gt; a
</span><span class="hs-identifier hs-var">sqrt</span></span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449066"><span class="hs-identifier hs-var">disc</span></a></span><span class="hs-special">)</span><span class="annot"><span class="annottext">a -&gt; a -&gt; a
forall a. Fractional a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">/</span></span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449061"><span class="hs-identifier hs-var">d</span></a></span><span>
</span><span id="line-80"></span><span>
</span><span id="line-81"></span><span id="local-6989586621679449051"><span class="annot"><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#midMaxPositiveInterval"><span class="hs-identifier hs-type">midMaxPositiveInterval</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Floating</span></span><span> </span><span class="annot"><a href="#local-6989586621679449051"><span class="hs-identifier hs-type">a</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ord</span></span><span> </span><span class="annot"><a href="#local-6989586621679449051"><span class="hs-identifier hs-type">a</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.BoolFunction.html#BoolFunction"><span class="hs-identifier hs-type">BoolFunction</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679449051"><span class="hs-identifier hs-type">a</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V</span></span><span> </span><span class="annot"><span class="hs-number">2</span></span><span> </span><span class="annot"><a href="#local-6989586621679449051"><span class="hs-identifier hs-type">a</span></a></span><span class="hs-special">)</span></span><span>
</span><span id="line-82"></span><span id="midMaxPositiveInterval"><span class="annot"><span class="annottext">midMaxPositiveInterval :: BoolFunction a -&gt; Maybe (V 2 a)
</span><a href="Hyperion.Bootstrap.OPESearch.BilinearForms.html#midMaxPositiveInterval"><span class="hs-identifier hs-var hs-var">midMaxPositiveInterval</span></a></span></span><span> </span><span id="local-6989586621679449049"><span class="annot"><span class="annottext">BoolFunction a
</span><a href="#local-6989586621679449049"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">BoolFunction a -&gt; [(a, a)]
forall a. BoolFunction a -&gt; [(a, a)]
</span><a href="Hyperion.Bootstrap.BoolFunction.html#trueRanges"><span class="hs-identifier hs-var">B.trueRanges</span></a></span><span> </span><span class="annot"><span class="annottext">BoolFunction a
</span><a href="#local-6989586621679449049"><span class="hs-identifier hs-var">f</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-83"></span><span>  </span><span class="hs-special">[</span><span class="hs-special">]</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Maybe (V 2 a)
forall a. Maybe a
</span><span class="hs-identifier hs-var">Nothing</span></span><span>
</span><span id="line-84"></span><span>  </span><span id="local-6989586621679449047"><span class="annot"><span class="annottext">[(a, a)]
</span><a href="#local-6989586621679449047"><span class="hs-identifier hs-var">trueRanges</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">V 2 a -&gt; Maybe (V 2 a)
forall a. a -&gt; Maybe a
</span><span class="hs-identifier hs-var">Just</span></span><span> </span><span class="annot"><span class="annottext">(V 2 a -&gt; Maybe (V 2 a)) -&gt; V 2 a -&gt; Maybe (V 2 a)
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span>
</span><span id="line-85"></span><span>    </span><span class="hs-keyword">let</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679449046"><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449046"><span class="hs-identifier hs-var">t1</span></a></span></span><span class="hs-special">,</span><span id="local-6989586621679449045"><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449045"><span class="hs-identifier hs-var">t2</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">((a, a) -&gt; a) -&gt; [(a, a)] -&gt; (a, a)
forall b a. (HasCallStack, Ord b) =&gt; (a -&gt; b) -&gt; [a] -&gt; a
</span><span class="hs-identifier hs-var">maximumOn</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">\</span><span class="hs-special">(</span><span id="local-6989586621679449044"><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449044"><span class="hs-identifier hs-var">l</span></a></span></span><span class="hs-special">,</span><span id="local-6989586621679449043"><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449043"><span class="hs-identifier hs-var">u</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449043"><span class="hs-identifier hs-var">u</span></a></span><span class="annot"><span class="annottext">a -&gt; a -&gt; a
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-glyph hs-var">-</span></span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449044"><span class="hs-identifier hs-var">l</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">[(a, a)]
</span><a href="#local-6989586621679449047"><span class="hs-identifier hs-var">trueRanges</span></a></span><span>
</span><span id="line-86"></span><span>    </span><span class="hs-keyword">in</span><span> </span><span class="annot"><span class="annottext">V 2 a -&gt; V 2 a
forall k (j :: k) a. (Dim j, Floating a) =&gt; V j a -&gt; V j a
</span><span class="hs-identifier hs-var">L.normalizeV</span></span><span> </span><span class="annot"><span class="annottext">(V 2 a -&gt; V 2 a) -&gt; V 2 a -&gt; V 2 a
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">HomogeneousTuple 2 a -&gt; V 2 a
forall (n :: Nat) a. TupleVector n =&gt; HomogeneousTuple n a -&gt; V n a
</span><span class="hs-identifier hs-var">L.toV</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">a
</span><span class="hs-number">1</span></span><span class="hs-special">,</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449046"><span class="hs-identifier hs-var">t1</span></a></span><span class="annot"><span class="annottext">a -&gt; a -&gt; a
forall a. Num a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">+</span></span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679449045"><span class="hs-identifier hs-var">t2</span></a></span><span class="hs-special">)</span><span class="annot"><span class="annottext">a -&gt; a -&gt; a
forall a. Fractional a =&gt; a -&gt; a -&gt; a
</span><span class="hs-operator hs-var">/</span></span><span class="annot"><span class="annottext">a
</span><span class="hs-number">2</span></span><span class="hs-special">)</span><span>
</span><span id="line-87"></span></pre></body></html>